exercises/acl/config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  root 'home#index'
  get 'signup', to: 'users#new'

  resource :session, only: %i[new create destroy]

  resources :users
  resources :posts
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

exercises/acl/app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

exercises/acl/app/models/post.rb
# frozen_string_literal: true

class Post < ApplicationRecord
  validates :title, presence: true
  validates :body, length: { maximum: 500 }

  belongs_to :author, class_name: 'User'
end

exercises/acl/app/models/user.rb
# frozen_string_literal: true

class User < ApplicationRecord
  has_secure_password

  validates :name, presence: true
  validates :email, presence: true
  validates :password, presence: true, length: { minimum: 6 }, allow_nil: true

  has_many :posts, foreign_key: 'author_id', dependent: :destroy
end

exercises/acl/app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
  include AuthConcern
  include Pundit
end

exercises/acl/app/controllers/concerns/auth_concern.rb
# frozen_string_literal: true

module AuthConcern
  extend ActiveSupport::Concern

  def sign_in(user)
    session[:user_id] = user.id
  end

  def sign_out
    session.delete(:user_id)
    session.clear
  end

  def signed_in?
    !current_user.nil?
  end

  def current_user
    @current_user ||= User.find_by(id: session[:user_id])
  end
end

exercises/acl/app/controllers/home_controller.rb
# frozen_string_literal: true

class HomeController < ApplicationController
  def index; end
end

exercises/acl/app/controllers/posts_controller.rb
# frozen_string_literal: true

class PostsController < ApplicationController
  after_action :verify_authorized, except: %i[index show]
  before_action :set_post, only: %i[show edit update destroy]

  # BEGIN
  def index
    @posts = Post.all
  end

  def show; end

  def new
    @post = Post.new
    authorize @post
  end

  def edit
    authorize @post
  end

  def create
    authorize Post
    @post = current_user.posts.build(post_params)

    if @post.save
      redirect_to @post, notice: t('.success')
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    authorize @post

    if @post.update(post_params)
      redirect_to @post, notice: t('.success')
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    authorize @post

    if @post.destroy
      redirect_to posts_path, notice: t('.success')
    else
      redirect_to post_path(@post), alert: 'Error deleting post'
    end
  end

  private

  def set_post
    @post = Post.find(params[:id])
  end

  def post_params
    params.require(:post).permit(:title, :body)
  end
  # END
end

exercises/acl/app/controllers/sessions_controller.rb
# frozen_string_literal: true

class SessionsController < ApplicationController
  def new; end

  def create
    user = User.find_by email: sign_in_params[:email]

    if user&.authenticate(sign_in_params[:password])
      sign_in user
      redirect_to user
    else
      redirect_to new_session_path, notice: t('.inсorrect')
    end
  end

  def destroy
    sign_out
    redirect_to root_path
  end

  private

  def sign_in_params
    params.require(:user).permit(:email, :password)
  end
end

exercises/acl/app/controllers/users_controller.rb
# frozen_string_literal: true

class UsersController < ApplicationController
  def index
    @users = User.all
  end

  def show
    @user = User.find params[:id]

    @posts = @user.posts
  end

  def new
    @user = User.new
  end

  def edit
    @user = User.find params[:id]
  end

  def create
    @user = User.new(user_params)

    if @user.save
      sign_in @user
      redirect_to @user, notice: 'User was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    @user = User.find params[:id]

    if @user.update(user_params)
      redirect_to @user, notice: 'User was successfully updated.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @user = User.find params[:id]

    @user.destroy

    redirect_to users_url, notice: 'User was successfully destroyed.'
  end

  private

  # Only allow a list of trusted parameters through.
  def user_params
    params.require(:user).permit(
      :name,
      :email,
      :password,
      :password_confirmation
    )
  end
end

exercises/acl/app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
  include AuthConcern
end

exercises/acl/app/views/layouts/shared/_flash.html.slim
- if flash.any?
  .container.my-2
    - flash.each do |_type, msg|
      .alert.alert-info
        = msg

exercises/acl/app/views/layouts/shared/_nav.html.slim
.container.mb-2
  .d-flex.flex-wrap.align-items-center.py-2.border-bottom
    .navbar.navbar-expand-md.navbar-light.me-auto
      = link_to root_path, class: 'navbar-brand me-md-4' do
        = image_tag asset_pack_path('media/images/logo.png'), width: 30, alt: t('.hexlet_logo')

      #navbarToggler.collapse.navbar-collapse
        ul.nav.nav-pills.flex-grow-1.navbar-nav.me-auto
          li.nav-item.me-2
            = link_to t('.home'), root_path, class: 'nav-link link-dark'
          li.nav-item.me-2
            = link_to t('.users'), users_path, class: 'nav-link link-dark'
          li.nav-item.me-2
            = link_to t('.posts'), posts_path, class: 'nav-link link-dark'

    ul.nav.nav-pills
      - if signed_in?
        li.nav-item.me-2
          = link_to t('.sign_out'), session_path, method: :delete, class: 'nav-link link-dark'
      - else
        li.nav-item.me-2
          = link_to t('.login'), new_session_path, class: 'nav-link link-dark'
        li.nav-item.me-2
          = link_to t('.signup'), signup_path, class: 'nav-link link-dark'